//+------------------------------------------------------------------+
//|                                                    Graal-003.mq4 |
//|                                        Copyright  2005, Registr |
//|                                                  Exsys@pochta.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Registr"
#property link      "Exsys@pochta.ru"


#include <stdlib.mqh>
//---- input parameters
extern double    Lots       =0.01;
extern int       TakeProfit=80;
extern int       StopLoss  =100;
extern int       Limit    =45;     //    
extern int       ProfitLevel= 20; //         
extern int       ModeOpeningOfWarrants=3;
/*   : 0 -   ,    ,
   1 -    ,   , 2 -   
   , 3 -     */
extern int       ModeClosingOfWarrants=1;
/*   : 0 -         ( 
   ,  , 1 -    ,   , 
   2 -    ,   , 3 -   ,  2 ,
        ( )*/
extern bool OpenOnlyOnDepthOfFChannel=false; /*       
 */
extern int  DepthOfFChannel=25; /*      ,  ,  
    ,    */
extern bool ReferenceOnChannel_HL=true; /*     High-Low,  ,
      Buy,      Low,  */
extern int  LevelOrientationOnChannel_HL=20; /*      High-Low,  
   ,    */
extern bool ToTradeInFlat=true; /*      */
extern int  LevelChannel_HLForFlat=20; /*  High-Low,     */
extern bool UseWPRInClosePositions=true; /*   WPR      */
extern int  ControlLevelWPR=30; /*   WPR*/
extern bool ToExposeContrwarrants=true; /*     */
extern bool OnlyOnePosition=true; 
/*  ,     ,   
       .       
    Buy    Sell,   .  ,     ,
   ..      . ,  ,      ...*/
extern bool      DeleteLogsOnClose=false; /*  log-,  4,    */
/*  ,  4     */
extern bool      EraseOldFileOfReport=true; /*   ,   FileNameOfReport  */
extern string    FileNameOfReport; /*  */
extern bool      UseSoundInOperations=false; /*    */
extern string    SoundOpenBuy="OpenBuy.wav"; /*    Buy*/
extern string    SoundOpenSell="OpenSell.wav"; /*    Sell*/
extern string    SoundOpenBuyStop="OpenBuyStop.wav"; /*    BuyStop*/
extern string    SoundOpenSellStop="OpenSellStop.wav"; /*    SellStop*/
extern string    SoundClosing="ClosePositions.wav"; /*    */
//----
static int magicNumber=123456;
static string NameOfExpert="Graal-003";
static datetime prev_min=D'1.1.1'; //    
static datetime prev_max=D'1.1.1'; //    
//----
bool AllowTrade,OpenBuy,OpenSell,StopWorkOfExpert,WorkWPR;
bool TrendUp,TrendDn,SignalOnClosing,CheckClose,LockForClose;
datetime PrevTime,TimeOfClosing;
int CountBars,CountSessions,CountOperations,CountOrders,CountBuy,CountSell;
int PerHL,TotalBuyStop,CountBuyStop,TotalSellStop,CountSellStop,MaximalDrawdown;
double iFractals_up,iFractals_lo,PrevPrice,FractalPrevUp,FractalPrevDn,UseOfDeposit;
double ChannelHLClose,MidLine,MaxH,MinL,SubMaxH,SubMinL,FChannel;
double CollectorBuy,CollectorSell,SubFractalUp,FractalUp,SubFractalDn,FractalDn;
double InfoOpenOrders[][4];
string FlagFractal;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   int buffer;
   //bool
   AllowTrade=true;OpenBuy=false;OpenSell=false;StopWorkOfExpert=false;
   WorkWPR=false;TrendUp=false;TrendDn=false;SignalOnClosing=false; CheckClose=false;
   LockForClose=true;
   //datetime
   PrevTime=Time[0];TimeOfClosing=0;
   //int
   CountBars=0;CountSessions=0;CountOperations=0;CountOrders=0;CountBuy=0;CountSell=0;
   MaximalDrawdown=0;PerHL=14;TotalBuyStop=0;CountBuyStop=0;TotalSellStop=0;CountSellStop=0;
   //double
   iFractals_up=0;iFractals_lo=0;PrevPrice=0;FractalPrevUp=0;FractalPrevDn=0;UseOfDeposit=0;
   CollectorBuy=0;CollectorSell=0;SubFractalUp=0;FractalUp=0;SubFractalDn=0;FractalDn=0;
   //string
   FlagFractal="";

   return(0);
  }

int start()
  {

   bool NewBar=false;int i,size;
   if (Time[0]!=PrevTime)
     {
      CountBars++;
      NewBar=True;
      PrevPrice=0;
      PrevTime=Time[0];
     }
   if((CountBuyStop>CalculationOfWarrants(Symbol(),0,4,0))||
      (CountSellStop>CalculationOfWarrants(Symbol(),0,5,0)))
     {
      int resSS=0,resSB=0,intSize=0;
      size=ArrayRange(InfoOpenOrders,0);
      for(i=0;i<size;i++)
        {
         if(OrderSelect(InfoOpenOrders[i][0],SELECT_BY_TICKET))
           {
            if(OrderType()==InfoOpenOrders[i][2]) continue;
            else
              {
               switch(OrderType())
                 {
                  case OP_BUY:
                     CountOperations++;
                     InfoOpenOrders[i][2]=OP_BUY;
                     FlagFractal="buy";
                     CountBuyStop--;
                     UseOfDeposit=UseOfDeposit+((NormalizeDouble(Ask,Digits)*1000)*OrderLots());
                     if(ToExposeContrwarrants&&AllowTrade)
                       {
                        CountOrders++;
                        resSS=PerformanceOpenSellStop(Symbol(),Lots,(FractalDn-(Limit*Point)),5,StopLoss,TakeProfit,
                        CountOrders+" SellStop "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenSellStop);
                        if(resSS>0)
                          {
                           CountSellStop++;TotalSellStop++;
                           intSize=ArrayRange(InfoOpenOrders,0);
                           ArrayResize(InfoOpenOrders,size+1);
                           InfoOpenOrders[intSize][0]=resSS;
                           InfoOpenOrders[intSize][1]=CountOrders;
                           InfoOpenOrders[intSize][2]=OP_SELLSTOP;
                           InfoOpenOrders[intSize][3]=NormalizeDouble((FractalDn-(Limit*Point)),Digits);
                          }
                        else
                          {
                           CountOrders--;
                          }
                       }
                     break;
                  case OP_SELL:
                     CountOperations++;
                     InfoOpenOrders[i][2]=OP_SELL;
                     FlagFractal="sell";
                     CountSellStop--;
                     UseOfDeposit=UseOfDeposit+((NormalizeDouble(Bid,Digits)*1000)*OrderLots());
                     if(ToExposeContrwarrants&&AllowTrade)
                       {
                        CountOrders++;
                        resSB=PerformanceOpenBuyStop(Symbol(),Lots,(FractalUp+(Limit*Point)),5,StopLoss,TakeProfit,
                        CountOrders+" SellStop "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenBuyStop);
                        if(resSB>0)
                          {
                           CountBuyStop++;TotalBuyStop++;
                           intSize=ArrayRange(InfoOpenOrders,0);
                           ArrayResize(InfoOpenOrders,size+1);
                           InfoOpenOrders[intSize][0]=resSB;
                           InfoOpenOrders[intSize][1]=CountOrders;
                           InfoOpenOrders[intSize][2]=OP_BUYSTOP;
                           InfoOpenOrders[intSize][3]=NormalizeDouble(FractalUp+(Limit*Point),Digits);
                          }
                        else
                          {
                           CountOrders--;
                          }
                       }
                     break;
                  default:
                     break;
                 }
              }
           }
        }
     }
   if(MaximalDrawdown>(CalculationOfWarrants(Symbol(),magicNumber,0,1)+CalculationOfWarrants(Symbol(),magicNumber,1,1)))
     {
      MaximalDrawdown=CalculationOfWarrants(Symbol(),magicNumber,0,1)+CalculationOfWarrants(Symbol(),magicNumber,1,1);
     }
   if (CalculationOfWarrants(Symbol(),magicNumber,6,1)>ProfitLevel)
     {
      AllowTrade=false;
      if(LockForClose)
        {
         SignalOnClosing=true;
        }
     }
   if(SignalOnClosing && UseWPRInClosePositions && LockForClose)
     {
      double InitWPRPrev=0,InitWPRCurr=0;
      InitWPRPrev=iWPR(Symbol(),0,14,1);
      InitWPRCurr=iWPR(Symbol(),0,14,0);
      if((InitWPRPrev>(0-ControlLevelWPR))&&(InitWPRCurr>InitWPRPrev))
        {
         WorkWPR=true;TrendUp=true;SignalOnClosing=false;
        }
      if((InitWPRPrev<(-100+ControlLevelWPR))&&(InitWPRCurr<InitWPRPrev))
        {
         WorkWPR=true;TrendDn=true;SignalOnClosing=false;
        }
      LockForClose=false;
     }
   if(WorkWPR)
     {
      double WPRPrev=0,WPRCurr=0;
      WPRPrev=iWPR(Symbol(),0,14,1);
      WPRCurr=iWPR(Symbol(),0,14,0);
      if(TrendUp&&(WPRCurr<(0-ControlLevelWPR)))
        {
         WorkWPR=false;TrendUp=false;SignalOnClosing=true;
        }
      if(TrendDn&&(WPRCurr>(-100+ControlLevelWPR)))
        {
         WorkWPR=false;TrendDn=false;SignalOnClosing=true;
        }
      if ((CalculationOfWarrants(Symbol(),magicNumber,0,1))
      +(CalculationOfWarrants(Symbol(),magicNumber,1,1))<ProfitLevel/2)
        {
         WorkWPR=false;TrendUp=false;TrendDn=false;SignalOnClosing=true;
        }
     }
   if(SignalOnClosing)
     {
      CloseAllPositions(Symbol(),magicNumber,ModeClosingOfWarrants);
      SetBadge("K",CurTime(),((Ask+Bid)/2)-3*Point,170,Violet);
      SignalOnClosing=false;LockForClose=false;CheckClose=true;
     }
   if(CheckClose)
     {
      if(CalculationOfWarrants(Symbol(),magicNumber,8,0)==0)
        {
         CountBuy=0;TotalSellStop=0;CountSellStop=0;CountSell=0;TotalBuyStop=0;CountBuyStop=0;
         TimeOfClosing=0;CollectorBuy=0;CollectorSell=0;UseOfDeposit=0;MaximalDrawdown=0;
         CountOperations=0;CountOrders=0;WorkWPR=false;TrendUp=false;TrendDn=false;
         SignalOnClosing=false;LockForClose=true;CheckClose=false;//FlagFractal="";
         ArrayResize(InfoOpenOrders,0);
         Sleep(5000);
         CountSessions++;
         AllowTrade=true;
        }
     }
   for(i=0; i < 300; i++)
     {
      iFractals_up=iFractals(NULL, 0, MODE_UPPER, i);
      iFractals_lo=iFractals(NULL, 0, MODE_LOWER, i);
      if ((iFractals_up!=0) || (iFractals_lo!=0)) break;
     }
   if ((iFractals_up!=0) && (Time[i]!=prev_max) && (i < 3))
     {
      prev_max=Time[i];
      if(AllowTrade)
        {
         OpenSell=true;
        }
     }
   if ((iFractals_lo!=0) && (Time[i]!=prev_min) && (i < 3))
     {
      prev_min=Time[i];
      if(AllowTrade)
        {
         OpenBuy=true;
        }
     }
   FractalUp=0;FractalDn=0;
   FractalUp=iFractals_up;
   FractalDn=iFractals_lo;
   if(FractalUp==0)
     {
      if(FractalPrevUp==0)
        {
         FractalUp=High[PerHL];
         for(i=0;i<PerHL;i++)
           {
            if (FractalUp<High[i]) FractalUp=High[i];
           }
        }
         else FractalUp=FractalPrevUp;
     }
      else FractalPrevUp=FractalUp;
   if(FractalDn==0)
     {
      if(FractalPrevDn==0)
        {
         FractalDn=Low[PerHL];
         for(i=0;i<PerHL;i++)
           {
            if (FractalDn>Low[i])  FractalDn=Low[i];
           }
        }
         else FractalDn=FractalPrevDn;
     }
      else FractalPrevDn=FractalDn;
   if(OpenOnlyOnDepthOfFChannel)
     {
      FChannel=MathRound((FractalUp-FractalDn)/Point);
      SubFractalUp=FractalUp-(((FChannel/100)*DepthOfFChannel)*Point);
      SubFractalDn=FractalDn+(((FChannel/100)*DepthOfFChannel)*Point);

      if(DepthOfFChannel>0)
        {
         if(OpenBuy)
           {
            RefreshRates();
            if(Close[0]<SubFractalDn)
              {
               OpenBuy=false;
               SetBadge("C",CurTime(),Close[0],76,MediumVioletRed);
              }
           }
         if(OpenSell)
           {
            RefreshRates();
            if(Close[0]>SubFractalUp)
              {
               OpenSell=false;
               SetBadge("C",CurTime(),Close[0],76,DodgerBlue);
              }
           }
        }
     }
   MaxH=Close[PerHL];MinL=Close[PerHL];
   for(i=1;i<PerHL;i++)
     {
      if (MaxH<Close[i]) MaxH=Close[i];
      if (MinL>Close[i]) MinL=Close[i];
     }
   MidLine=NormalizeDouble((MaxH+MinL)/2,Digits);
   ChannelHLClose=MathRound((MaxH-MinL)/Point);
   if(ReferenceOnChannel_HL)
     {
      SubMaxH=MaxH-(((ChannelHLClose/100)*LevelOrientationOnChannel_HL)*Point);
      SubMinL=MinL+(((ChannelHLClose/100)*LevelOrientationOnChannel_HL)*Point);
      if(LevelOrientationOnChannel_HL>0)
        {
         if(OpenBuy)
           {
            RefreshRates();
            if(Close[0]<SubMinL)
              {
               OpenBuy=false;
               SetBadge("R",CurTime(),Close[0],251,MediumVioletRed);
              }
           }
         if(OpenSell)
           {
            RefreshRates();
            if(Close[0]>SubMaxH)
              {
               OpenSell=false;
               SetBadge("R",CurTime(),Close[0],251,DodgerBlue);
              }
           }
        }
     }
   if(!ToTradeInFlat)
     {
      if((ChannelHLClose<LevelChannel_HLForFlat)
      &&(CalculationOfWarrants(Symbol(),magicNumber,0,0)==CalculationOfWarrants(Symbol(),magicNumber,1,0)))
        {
         if(OpenBuy)
           {
            SetBadge("F",CurTime(),((Ask+Bid)/2)-3*Point,104,MediumVioletRed);
            OpenBuy=false;
           }
         if(OpenSell)
           {
            SetBadge("F",CurTime(),((Ask+Bid)/2)+3*Point,104,DodgerBlue);
            OpenSell=false;
           }
        }
     }
   if(OnlyOnePosition&&ToExposeContrwarrants)
     {
      if(OpenBuy)
        {
         if(CalculationOfWarrants(Symbol(),magicNumber,0,0)>0)
           {
            OpenBuy=false;
           }
        }
      if(OpenSell)
        {
         if(CalculationOfWarrants(Symbol(),magicNumber,1,0)>0)
           {
            OpenSell=false;
           }
        }
     }
   if(OpenBuy)
     {
      if(FlagFractal=="buy")
        {
         SetBadge("Z",CurTime(),((Ask+Bid)/2)-3*Point,65,MediumVioletRed);
         OpenBuy=false;

        }

     }
   if(OpenSell)
     {
      if(FlagFractal=="sell")
        {
         SetBadge("Z",CurTime(),((Ask+Bid)/2)+3*Point,65,DodgerBlue);
         OpenSell=false;

        }

     }
   if((OpenBuy)&&(AllowTrade))
     {
      int resBuy,resSellStop,process1=0,mode1=ModeOpeningOfWarrants;
      CountOperations++;

      SetBadge("B",CurTime(),((Ask+Bid)/2)-3*Point,241,Red);
      if((mode1==0)||(mode1==1)) process1=2;
      if((mode1==2)||(mode1==3)) process1=1;
      while(process1>0)
        {
         if((mode1==0)||(mode1==2))
           {
            CountOrders++;
            resBuy=PerformanceOpenBuy(Symbol(),Lots,5,StopLoss,TakeProfit,CountOrders
            +" Buy "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenBuy);
            if(resBuy>0)
              {
               CountBuy++;process1--;FlagFractal="buy";
               size=ArrayRange(InfoOpenOrders,0);
               ArrayResize(InfoOpenOrders,size+1);
               InfoOpenOrders[size][0]=resBuy;
               InfoOpenOrders[size][1]=CountOrders;
               InfoOpenOrders[size][2]=OP_BUY;
               InfoOpenOrders[size][3]=NormalizeDouble(Ask,Digits);
               UseOfDeposit=UseOfDeposit+((NormalizeDouble(Ask,Digits)*1000)*Lots);
              }
            else
              {

               CountOrders--;
               break;
              }
            if(mode1==0) mode1=3;
           }
         if((mode1==1)||(mode1==3))
           {
            CountOrders++;
            resSellStop=PerformanceOpenSellStop(Symbol(),Lots,(FractalDn-(Limit*Point)),5,StopLoss,TakeProfit,
            CountOrders+" SellStop "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenSellStop);
            if(resSellStop>0)
              {
               CountSellStop++;TotalSellStop++;process1--;
               size=ArrayRange(InfoOpenOrders,0);
               ArrayResize(InfoOpenOrders,size+1);
               InfoOpenOrders[size][0]=resSellStop;
               InfoOpenOrders[size][1]=CountOrders;
               InfoOpenOrders[size][2]=OP_SELLSTOP;
               InfoOpenOrders[size][3]=NormalizeDouble((FractalDn-(Limit*Point)),Digits);
              }
            else
              {

               CountOrders--;
               break;
              }
            if(mode1==1) mode1=2;
           }
        }

      OpenBuy=false;
     }
   if((OpenSell)&&(AllowTrade))
     {
      int resSell,resBuyStop,process2=0,mode2=ModeOpeningOfWarrants;
      CountOperations++;

      SetBadge("S",CurTime(),((Ask+Bid)/2)+7*Point,242,Blue);
      if((mode2==0)||(mode2==1)) process2=2;
      if((mode2==2)||(mode2==3)) process2=1;
      while(process2>0)
        {
         if((mode2==0)||(mode2==2))
           {
            CountOrders++;
            resSell=PerformanceOpenSell(Symbol(),Lots,5,StopLoss,TakeProfit,CountOrders
            +" Sell "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenSell);
            if(resSell>0)
              {
               CountSell++;process2--;FlagFractal="sell";
               size=ArrayRange(InfoOpenOrders,0);
               ArrayResize(InfoOpenOrders,size+1);
               InfoOpenOrders[size][0]=resSell;
               InfoOpenOrders[size][1]=CountOrders;
               InfoOpenOrders[size][2]=OP_SELL;
               InfoOpenOrders[size][3]=NormalizeDouble(Bid,Digits);
               UseOfDeposit=UseOfDeposit+((NormalizeDouble(Bid,Digits)*1000)*Lots);
              }
            else
              {

               CountOrders--;
               break;
              }
            if(mode2==0) mode2=3;
           }
         if((mode2==1)||(mode2==3))
           {
            CountOrders++;
            resBuyStop=PerformanceOpenBuyStop(Symbol(),Lots,(FractalUp+(Limit*Point)),5,StopLoss,TakeProfit,
            CountOrders+" SellStop "+NameOfExpert,magicNumber,UseSoundInOperations,SoundOpenBuyStop);
            if(resBuyStop>0)
              {
               CountBuyStop++;TotalBuyStop++;process2--;
               size=ArrayRange(InfoOpenOrders,0);
               ArrayResize(InfoOpenOrders,size+1);
               InfoOpenOrders[size][0]=resBuyStop;
               InfoOpenOrders[size][1]=CountOrders;
               InfoOpenOrders[size][2]=OP_BUYSTOP;
               InfoOpenOrders[size][3]=NormalizeDouble(FractalUp+(Limit*Point),Digits);
              }
            else
              {

               CountOrders--;
               break;
              }
            if(mode2==1) mode2=2;
           }
        }

      OpenSell=false;
     }
   if(!IsTesting())
     {
      string com=(": "+GetCurRusTime());
      if(OpenOnlyOnDepthOfFChannel) { com=com + ("   FChannel: "+DoubleToStr(FChannel,2)); }
      if(ReferenceOnChannel_HL) { com=com + ("   ChannelHLClose: "+DoubleToStr(ChannelHLClose,2)); }
      Comment(com);
     }
   return(0);
  }

string CheckSoundFileName(string SoundFileName)
  {
   if(StringLen(SoundFileName)==0)
     {
      return("     .");
     }
   else
      if((StringFind(SoundFileName,".wav",0))!=(StringLen(SoundFileName)-4))
        {
         return("     .");
        }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int CalculationOfWarrants(string NameOfToll,int UniqueMagic,int Index1,int Index2)
  {
   int Inform[9][2],Zero[9][2];int n=0;
   ArrayCopy(Inform,Zero,0,0,WHOLE_ARRAY);
   bool Condition1;
   if(UniqueMagic==0)
     {
      Condition1=(OrderSymbol()==NameOfToll);
     }
   else
     {
      Condition1=((OrderSymbol()==NameOfToll)&&(OrderMagicNumber()==UniqueMagic));
     }
   for(n=OrdersTotal()-1;n>=0;n--)
     {
      OrderSelect(n,SELECT_BY_POS,MODE_TRADES);
      if (Condition1)
        {
         if(OrderType()==0) {Inform[0][0]=Inform[0][0]+1;Inform[0][1]=Inform[0][1]+OrderProfit();}
         if(OrderType()==1) {Inform[1][0]=Inform[1][0]+1;Inform[1][1]=Inform[1][1]+OrderProfit();}
         if(OrderType()==2) {Inform[2][0]=Inform[2][0]+1;}
         if(OrderType()==3) {Inform[3][0]=Inform[3][0]+1;}
         if(OrderType()==4) {Inform[4][0]=Inform[4][0]+1;}
         if(OrderType()==5) {Inform[5][0]=Inform[5][0]+1;}
        }
     }
   Inform[6][0]=Inform[0][0]+Inform[1][0];
   Inform[6][1]=Inform[0][1]+Inform[1][1];
   Inform[7][0]=Inform[2][0]+Inform[3][0]+Inform[4][0]+Inform[5][0];
   Inform[8][0]=Inform[0][0]+Inform[1][0]+Inform[2][0]+Inform[3][0]
   +Inform[4][0]+Inform[5][0];
   return(Inform[Index1][Index2]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*void WriteLineInFile(string FileName,string Line)
  {
   int HFile=FileOpen(FileName,FILE_READ|FILE_WRITE," ");
   if(HFile>0)
     {
      FileSeek(HFile,0,SEEK_END);
      FileWrite(HFile,Line);
      FileFlush(HFile);
      FileClose(HFile);
     }
   return;
  }*/
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetCurRusTime()
  {
   string StrMonth="",StrDay="",StrHour="",StrMinute="",StrSeconds="";
   RefreshRates();
   if(Month()<10) { StrMonth="0"+Month(); } else { StrMonth=Month(); }
   if(Day()<10) { StrDay="0"+Day(); } else { StrDay=Day(); }
   if(Hour()<10) { StrHour="0"+Hour(); } else { StrHour=Hour(); }
   if(Minute()<10) { StrMinute="0"+Minute(); } else { StrMinute=Minute(); }
   if(Seconds()<10) { StrSeconds="0"+Seconds(); } else { StrSeconds=Seconds(); }
   return(""+StrDay+"."+StrMonth+"."+Year()+" "+StrHour+":"+StrMinute+":"+StrSeconds+" ");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetBadge(string BadgeName, datetime BadgeTime, double BadgePrice,int BadgeType,color BadgeColor)
  {
   string Name=BadgeName+CurTime();
   if(PrevPrice>0)
     {
      if(((BadgePrice-PrevPrice)>=0*Point)&&((BadgePrice-PrevPrice)<3*Point)) BadgePrice=BadgePrice+3*Point;
      if(((PrevPrice-BadgePrice)>=0*Point)&&((PrevPrice-BadgePrice)<3*Point)) BadgePrice=BadgePrice-3*Point;
     }
   ObjectCreate(Name,OBJ_ARROW,0,BadgeTime,BadgePrice);
   ObjectSet(Name,OBJPROP_ARROWCODE,BadgeType);
   ObjectSet(Name,OBJPROP_COLOR,BadgeColor);
   PrevPrice=BadgePrice;
  }

int PerformanceOpenBuy(string Toll,double SizeOfLot,int Accuracy,int FixingOfLoss,
int FixingOfProfit,string Note,int UniqueNumber,bool UseSound=false,string NameOfSound="")
  {
   double OpenPrice=0,SL=0,TP=0;int ticket=0,index=0,err=0,attempt=0;datetime InitialTime=CurTime();
   while(ticket<=0)
     {
      while(!IsTradeAllowed()) Sleep(1000);
      RefreshRates();
      OpenPrice=NormalizeDouble(Ask,Digits);
      SL=OpenPrice - FixingOfLoss   * Point;
      TP=OpenPrice + FixingOfProfit * Point;
      ticket=OrderSend(Toll,OP_BUY,SizeOfLot,OpenPrice,Accuracy,SL,TP,Note,UniqueNumber,0,Gold);
      if(ticket>0)
        {
         if(!IsTesting())
           {
            if((UseSound)&&(CheckSoundFileName(NameOfSound)=="")) PlaySound(NameOfSound);
           }
         index=StringFind(Note," ", 0);
         Sleep(5000);
         return(ticket);
        }
      else
        {
         err=GetLastError();attempt++;
         Print(TimeToStr(CurTime(),TIME_SECONDS)+" InitialTime: "+TimeToStr(InitialTime,TIME_SECONDS)
         +"     Buy, : "+ErrorDescription(err));
         if((err==135)&&(Accuracy<11)) Accuracy++;
         if(((CurTime()-InitialTime)>180)||(attempt==10)) break;
         Sleep(1000);
        }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PerformanceOpenSell(string Toll,double SizeOfLot,int Accuracy,int FixingOfLoss,
int FixingOfProfit,string Note,int UniqueNumber,bool UseSound=false,string NameOfSound="")
  {
   double OpenPrice=0,SL=0,TP=0;int ticket=0,index=0,err=0,attempt=0;datetime InitialTime=CurTime();
   while(ticket<=0)
     {
      while(!IsTradeAllowed()) Sleep(1000);
      RefreshRates();
      OpenPrice=NormalizeDouble(Bid,Digits);
      SL=OpenPrice + StopLoss   * Point;
      TP=OpenPrice - TakeProfit * Point;
      ticket=OrderSend(Toll,OP_SELL,SizeOfLot,OpenPrice,Accuracy,SL,TP,Note,UniqueNumber,0,DeepSkyBlue);
      if(ticket>0)
        {
         if(!IsTesting())
           {
            if((UseSound)&&(CheckSoundFileName(NameOfSound)=="")) PlaySound(NameOfSound);
           }
         index=StringFind(Note," ", 0);
         Sleep(5000);
         return(ticket);
        }
      else
        {
         err=GetLastError();attempt++;
         Print(TimeToStr(CurTime(),TIME_SECONDS)+" InitialTime: "+TimeToStr(InitialTime,TIME_SECONDS)
         +"     Sell, : "+ErrorDescription(err));
         if((err==135)&&(Accuracy<11)) Accuracy++;
         if(((CurTime()-InitialTime)>180)||(attempt==10)) break;
         Sleep(1000);
        }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PerformanceOpenBuyStop(string Toll,double SizeOfLot,double OpenPrice,int Accuracy,int FixingOfLoss,
int FixingOfProfit,string Note,int UniqueNumber,bool UseSound=false,string NameOfSound="")
  {
   double SL=0,TP=0;int ticket=0,index=0,err=0,attempt=0;datetime InitialTime=CurTime();
   while(ticket<=0)
     {
      while(!IsTradeAllowed()) Sleep(1000);
      RefreshRates();
      OpenPrice=NormalizeDouble(OpenPrice,Digits);
      SL=OpenPrice - FixingOfLoss   * Point;
      TP=OpenPrice + FixingOfProfit * Point;
      ticket=OrderSend(Toll,OP_BUYSTOP,SizeOfLot,OpenPrice,Accuracy,SL,TP,Note,UniqueNumber,0,Orange);
      if(ticket>0)
        {
         if(!IsTesting())
           {
            if((UseSound)&&(CheckSoundFileName(NameOfSound)=="")) PlaySound(NameOfSound);
           }
         index=StringFind(Note," ", 0);
         Sleep(5000);
         return(ticket);
        }
      else
        {
         err=GetLastError();attempt++;
         Print(TimeToStr(CurTime(),TIME_SECONDS)+" InitialTime: "+TimeToStr(InitialTime,TIME_SECONDS)
         +"    BuyStop, : "+ErrorDescription(err));
         if((err==135)&&(Accuracy<11)) Accuracy++;
         if(((CurTime()-InitialTime)>180)||(attempt==10)) break;
         Sleep(1000);
        }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PerformanceOpenSellStop(string Toll,double SizeOfLot,double OpenPrice,int Accuracy,int FixingOfLoss,
int FixingOfProfit,string Note,int UniqueNumber,bool UseSound=false,string NameOfSound="")
  {
   double SL=0,TP=0;int ticket=0,index=0,err=0,attempt=0;datetime InitialTime=CurTime();
   while(ticket<=0)
     {
      while(!IsTradeAllowed()) Sleep(1000);
      RefreshRates();
      OpenPrice=NormalizeDouble(OpenPrice,Digits);
      SL=OpenPrice + StopLoss   * Point;
      TP=OpenPrice - TakeProfit * Point;
      ticket=OrderSend(Toll,OP_SELLSTOP,SizeOfLot,OpenPrice,Accuracy,SL,TP,Note,UniqueNumber,0,Blue);
      if(ticket>0)
        {
         if(!IsTesting())
           {
            if((UseSound)&&(CheckSoundFileName(NameOfSound)=="")) PlaySound(NameOfSound);
           }
         index=StringFind(Note," ", 0);
         Sleep(5000);
         return(ticket);
        }
      else
        {
         err=GetLastError();attempt++;
         Print(TimeToStr(CurTime(),TIME_SECONDS)+" InitialTime: "+TimeToStr(InitialTime,TIME_SECONDS)
         +"    SellStop, : "+ErrorDescription(err));
         if((err==135)&&(Accuracy<11)) Accuracy++;
         if(((CurTime()-InitialTime)>180)||(attempt==10)) break;
         Sleep(1000);
        }
     }
   return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseAllPositions(string NameOfToll,int UniqueMagic,int ModeClosing)
  {
   bool WorkWarrant=false,PostWarrant=false,result=false;
   int attempt,cnt,index=0,NumberOfTry=2,PauseAfterError=1;
   double TimeProfit;
   datetime InitTime=CurTime();
//----
   if(ModeClosing==0) {WorkWarrant=true;PostWarrant=true;}
   if(ModeClosing==1) {WorkWarrant=true;PostWarrant=false;}
   if(ModeClosing==2) {WorkWarrant=false;PostWarrant=true;}
   CountOperations++;
   while(OrdersTotal()>0)
     {
      for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
        {
         result=false;
         TimeProfit=0;
         if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
           {
            if ((OrderSymbol()==NameOfToll)&&(OrderMagicNumber()==UniqueMagic))
              {
               for(attempt=0;attempt<NumberOfTry;attempt++)
                 {
                  RefreshRates();
                  while(!IsTradeAllowed()) Sleep(2000);
                  if((OrderType()==0)&&WorkWarrant)
                    {
                     TimeProfit=OrderProfit();
                     result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),5,Yellow);
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        CollectorBuy=CollectorBuy+TimeProfit;
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  Buy  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                  if((OrderType()==1)&&WorkWarrant)
                    {
                     TimeProfit=OrderProfit();
                     result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),5,Blue );
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        CollectorSell=CollectorSell+TimeProfit;
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  Sell  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                  if((OrderType()==2)&&PostWarrant)
                    {
                     result=OrderDelete(OrderTicket());
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  BuyLimit  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                  if((OrderType()==3)&&PostWarrant)
                    {
                     result=OrderDelete(OrderTicket());
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  SellLimit  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                  if((OrderType()==4)&&PostWarrant)
                    {
                     result=OrderDelete(OrderTicket());
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  BuyStop  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                  if((OrderType()==5)&&PostWarrant)
                    {
                     result=OrderDelete(OrderTicket());
                     if (result)
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Sleep(2000);
                        break;
                       }
                     else
                       {
                        index=StringFind(OrderComment()," ", 0);
                        Alert("  SellStop  "+OrderTicket()+"   "+StringSubstr(OrderComment(),0,index)
                        +"   . : "+ErrorDescription(GetLastError())+"  "+attempt+1);
                        if(ModeClosing==1) {PostWarrant=true;}
                        Sleep(1000*PauseAfterError);
                       }
                    }
                 }
               if((ModeClosing==1)&&(CalculationOfWarrants(NameOfToll,UniqueMagic,6,0)==0))
               {PostWarrant=true;}
               if((ModeClosing==2)&&(CalculationOfWarrants(NameOfToll,UniqueMagic,7,0)==0))
               {WorkWarrant=true;cnt=OrdersTotal();}
              }
           }
       }
     }
   TimeOfClosing=CurTime()-InitTime;

   return;
  }
//+------------------------------------------------------------------+